Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::SymScaledMatrix Class Reference

Class for a Matrix in conjunction with its scaling factors for row and column scaling. More...

`#include <IpSymScaledMatrix.hpp>`

Inheritance diagram for Ipopt::SymScaledMatrix:
[legend]

## Public Member Functions
void | SetUnscaledMatrix (const SmartPtr< const SymMatrix > unscaled_matrix)
| Set the unscaled matrix. More...
void | SetUnscaledMatrixNonConst (const SmartPtr< SymMatrix > &unscaled_matrix)
| Set the unscaled matrix in a non-const version. More...
SmartPtr< const SymMatrix > | GetUnscaledMatrix () const
| Return the unscaled matrix in const form. More...
SmartPtr< SymMatrix > | GetUnscaledMatrixNonConst ()
| Return the unscaled matrix in non-const form. More...
SmartPtr< const Vector > | RowColScaling () const
| return the vector for the row and column scaling More...
Constructors / Destructors
| SymScaledMatrix (const SymScaledMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
| ~SymScaledMatrix ()
| Destructor. More...
Public Member Functions inherited from Ipopt::SymMatrix
SmartPtr< const SymMatrixSpace > | OwnerSymMatrixSpace () const
| SymMatrix (const SymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~SymMatrix ()
| Destructor. More...
Index | Dim () const
| Dimension of the matrix (number of rows and columns) More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Methods overloaded from Matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::SymMatrix
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Since the matrix is symmetric, it is only necessary to implement the MultVectorImpl method in a class that inherits from this base class. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Since the matrix is symmetric, the row and column max norms are identical. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| SymScaledMatrix ()
| Default Constructor. More...
| SymScaledMatrix (const SymScaledMatrix &)
| Copy Constructor. More...
void | operator= (const SymScaledMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
SmartPtr< const SymMatrix > | matrix_
| const version of the unscaled matrix More...
SmartPtr< SymMatrix > | nonconst_matrix_
| non-const version of the unscaled matrix More...
SmartPtr< const SymScaledMatrixSpace > | owner_space_
| Matrix space stored as a SymScaledMatrixSpace. More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for a Matrix in conjunction with its scaling factors for row and column scaling.

Operations on the matrix are performed using the scaled matrix. You can pull out the pointer to the unscaled matrix for unscaled calculations.

Definition at line 26 of file IpSymScaledMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::SymScaledMatrix::SymScaledMatrix | ( | const SymScaledMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::SymScaledMatrix::~SymScaledMatrix | ( |  | ) |

Destructor.

Ipopt::SymScaledMatrix::SymScaledMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::SymScaledMatrix::SymScaledMatrix | ( | const SymScaledMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

void Ipopt::SymScaledMatrix::SetUnscaledMatrix | ( | const SmartPtr< const SymMatrix > | unscaled_matrix | ) |
| inline

Set the unscaled matrix.

Definition at line 194 of file IpSymScaledMatrix.hpp.

void Ipopt::SymScaledMatrix::SetUnscaledMatrixNonConst | ( | const SmartPtr< SymMatrix > & | unscaled_matrix | ) |
| inline

Set the unscaled matrix in a non-const version.

Definition at line 202 of file IpSymScaledMatrix.hpp.

SmartPtr< const SymMatrix > Ipopt::SymScaledMatrix::GetUnscaledMatrix | ( |  | ) | const
| inline

Return the unscaled matrix in const form.

Definition at line 210 of file IpSymScaledMatrix.hpp.

SmartPtr< SymMatrix > Ipopt::SymScaledMatrix::GetUnscaledMatrixNonConst | ( |  | ) |
| inline

Return the unscaled matrix in non-const form.

Definition at line 216 of file IpSymScaledMatrix.hpp.

SmartPtr< const Vector > Ipopt::SymScaledMatrix::RowColScaling | ( |  | ) | const
| inline

return the vector for the row and column scaling

Definition at line 223 of file IpSymScaledMatrix.hpp.

virtual void Ipopt::SymScaledMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::SymScaledMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

It is assumed here that the scaling factors are always valid numbers.

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::SymScaledMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::SymScaledMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::SymScaledMatrix::operator= | ( | const SymScaledMatrix & |  | ) |
| private

Overloaded Equals Operator.

## Member Data Documentation

SmartPtr<const SymMatrix> Ipopt::SymScaledMatrix::matrix_
| private

const version of the unscaled matrix

Definition at line 97 of file IpSymScaledMatrix.hpp.

SmartPtr<SymMatrix> Ipopt::SymScaledMatrix::nonconst_matrix_
| private

non-const version of the unscaled matrix

Definition at line 99 of file IpSymScaledMatrix.hpp.

SmartPtr<const SymScaledMatrixSpace> Ipopt::SymScaledMatrix::owner_space_
| private

Matrix space stored as a SymScaledMatrixSpace.

Definition at line 102 of file IpSymScaledMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpSymScaledMatrix.hpp